// -*- c++ -*-
/*****************************************************************************
 * class: Form
 *****************************************************************************/
#ifndef FORM_H
#define FORM_H

#include <gtk/gtk.h>

#include "TshObj.h"

class Type;
class Pop;
class RowData;

class Form : public TshWgt
{
private:
  Type*  T;
  Pop*   P;
  GList* L;        // Entry List
  GtkCTreeNode* R; // CTree Node     ... Ref 
  RowData* Rd;     // Ref
  int I;
  GtkWidget* Vb,* Tb;
  GtkWidget* B[3];  // Button 0:Ok, 1:Apply, 2:Cancel
  void init();
  void setEvents();

public:
  Form(FILE*, Type*, Pop*);
  ~Form();
  GtkWidget* create(FILE*);
  void createTitle(char*);
  void createEntry(char*, bool);
  void createButtons(char*);
  void clearEntrys();
  void attach(GtkWidget*, int, int);
  char* getText(int);
  void setText(int, char*);
  void setRd(GList*);
  void resetRd();
  GList* getRd();
  void setR(GtkCTreeNode*);
  char* getLabel();
  void setLabel(char*);

  static void ok(GtkWidget*, Form*);
  static void apply(GtkWidget*, Form*);
  static void cancel(GtkWidget*, Form*);
};

class FMgr : public TshWgt
{
private:
  Form* F;

public:
  FMgr();
  ~FMgr(){};
  void show();
  void hide();
  void set(Form* _F);
  GtkWidget* getPP();
};

#endif
