// -*- c++ -*- 
/*****************************************************************************
 * class Type
 *****************************************************************************/
#ifndef TYPE_H
#define TYPE_H

#include <gtk/gtk.h>

#include "TshObj.h"

class Pop;
class Icon;
class Form;
class TypeMgr;

enum { TS_NAME, TS_TYPE, TS_CMD, TS_ICN, TS_PATH, TS_SIZE };

class Type : public TshObj
{
private:
  char*  S[TS_SIZE]; // 0.Name 1.Command Type 2.Command String 3.Icon String
  void   setS(char*, int);
  Icon*  I;          // Icon Ref
  Pop*   P;          // PopUp Menu New
  Form*  F;          // Form New
  TypeMgr* Tm;       // Next Level Mgr New

public:
  Type(char*);
  ~Type();
  void init();
  char* getS(int);
  void  setCmd();
  void  setIcon();
  Icon* getIcon();
  bool  match(char*);
  void  setMgr();
  Type* lookup(char*);
  void  newPop();
  void  popUp(GdkEventButton*);
  void  newForm();
  Form* getForm();
  bool  isForm();

  //test
  void print();
};

/*
 * class TypeMgr
 */
class TypeMgr : public TshObj
{
private:
  GList* Tl;   // Type List

public:
  TypeMgr(char*);
  ~TypeMgr();
  void  init();
  void  create(char*);
  void  typeNew(char*);
  Type* getType(char*);
  Type* lookup(char*);
};
#endif
